unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Wiskunde, Fysica, Algemeen;

type
  TForm1 = class(TForm)
    Image1: TImage;
    procedure tekenen(Sender: TObject; var Key: Char);
    procedure starten(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure sturen;
{
  Front Wheels
}
var
  i,j : integer;
  t,dt : double;
  v : vektor;
begin
  t := 0;
  dt := 0.01;
  Fysica.starten;
  v := kromme(0);
  i := x2i(v.x);
  j := y2j(v.y);
  Form1.Image1.Canvas.MoveTo(i,j);
  while v.x <= 6*straal do
  begin
    t := t + dt;
    v := kromme(t);
    i := x2i(v.x);
    j := y2j(v.y);
    Form1.Image1.Canvas.LineTo(i,j);
  end;
end;

procedure achter;
{
  Rear Wheels
}
var
  i,j : integer;
  t,dt : double;
  v,w : vektor;
begin
  t := 0;
  dt := 0.01;
  Fysica.starten;
  rS := kromme(0);
  v := rS;
  i := x2i(rS.x);
  j := y2j(rS.y);
  Form1.Image1.Canvas.MoveTo(i,j);
  while v.x <= Sx*straal do
  begin
    t := t + dt;
    w := v;
    v := kromme(t);
    volgende(min(v,w));
    i := x2i(rA.x);
    j := y2j(rA.y);
    Form1.Image1.Canvas.LineTo(i,j);
  end;
end;

procedure allebei;
{
  Rear and Front Wheels
}
var
  i_S,j_S,i_A,j_A : integer;
  t,dt : double;
  v,w : vektor;
  keer : integer;
begin
  t := 0;
  dt := 0.01;
  Fysica.starten;
  rS := kromme(0);
  L := samen(0.5*straal,0);
  rA := min(rS,L);
  i_S := x2i(rS.x);
  j_S := y2j(rS.y);
  i_A := x2i(rA.x);
  j_A := y2j(rA.y);
  Form1.Image1.Canvas.MoveTo(i_A,j_A);
  Form1.Image1.Canvas.LineTo(i_S,j_S);
  v := rS;
  keer := 0;
  while v.x <= 6*straal do
  begin
    keer := keer + 1;
    t := t + dt;
    w := v;
    v := kromme(t);
    volgende(min(v,w));
    i_S := x2i(rS.x);
    j_S := y2j(rS.y);
    i_A := x2i(rA.x);
    j_A := y2j(rA.y);
    if (keer mod 25) > 0 then Continue;
    Form1.Image1.Canvas.MoveTo(i_A,j_A);
    Form1.Image1.Canvas.LineTo(i_S,j_S);
  end;
end;

procedure analytisch;
{
  Exact for Circle
}
var
  k : integer;
  Ri,dh,x,y : double;
begin
{
  Curve Rear Wheels
}
  Ri := sqrt(sqr(straal) - sqr(lengte(L)));
  with Form1.Image1.Canvas do
    Pen.Color := clBlue;
  x := straal*3 + Ri;
  y := straal*1.5;
  with Form1.Image1.Canvas do
    MoveTo(x2i(x),y2j(y));
  dh := Pi/180;
  for k := 0 to 360 do
  begin
    x := straal*3 + Ri*cos(k*dh);
    y := straal*1.5 + Ri*sin(k*dh);
    with Form1.Image1.Canvas do
      LineTo(x2i(x),y2j(y));
  end;
end;

procedure TForm1.tekenen(Sender: TObject; var Key: Char);
{
  Final Curve Drawing
}
begin
  straal := 1;
  if manier = 0 then ClearDevice(Form1.Image1);
  Form1.Image1.Canvas.Pen.Color := clGreen;
  sturen;
  rS := kromme(0);
  L := samen(0.5*straal,0);
  rA := min(rS,L);
  Form1.Image1.Canvas.MoveTo(10,10);
  Form1.Image1.Canvas.Pen.Color := clBlack;
  Form1.Image1.Canvas.LineTo(10+x2i(L.x),10);
  Form1.Image1.Canvas.Pen.Color := clRed;
  achter;
  Form1.Image1.Canvas.Pen.Color := clBlack;
  allebei;
  analytisch;
  manier := manier + 1;
  if manier = 2 then manier := 0;
end;

procedure TForm1.starten(Sender: TObject);
{
  Initialization
}
begin
  manier := 0;
  Sx := 7;
  Sy := 3;
  traject := 1;
end;

end.
