Unit Algemeen;
{
  Graphics Routines
}
INTERFACE

Uses Extctrls, Types, Graphics;

var
  Wijd,Hoog : integer; { screen sizes }
  Sx,Sy : double;  { real world sizes }

procedure ClearDevice(scherm : TImage);
function x2i(x : double) : integer;
function i2x(i : integer) : double;
function y2j(y : double) : integer;
function j2y(j : integer) : double;

IMPLEMENTATION

procedure ClearDevice(scherm : TImage);
{
  Clear Screen
}
var
  rechthoek : TRect;
begin
  Wijd := scherm.Width-1;
  Hoog := scherm.Height-1;
  rechthoek := Rect(0,0,Wijd+1,Hoog+1);
  with scherm.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(rechthoek);
  end;
end;

function x2i(x : double) : integer;
{
  Convert x-coordinate
  to screen coordinate
}
begin
  x2i := Round(x*Wijd/Sx);
end;

function i2x(i : integer) : double;
{
  Convert screen coordinate
  to real world x-coordinate
}
begin
  i2x := i*Sx/Wijd;
end;

function y2j(y : double) : integer;
{
  Convert y-coordinate
  to screen coordinate
}
begin
  y2j := Round(Hoog*(1-y/Sy));
end;

function j2y(j : integer) : double;
{
  Convert screen coordinate
  to real world y-coordinate
}
begin
  j2y := (Hoog-j)*Sy/Hoog;
end;

END.
