Unit Fysica;

INTERFACE

Uses Wiskunde;

var
  manier,traject : integer;
  rA,rS,L : vektor; { Back, Front, Length }
  straal : double;
  start : array of double;

procedure volgende(drS : vektor);
procedure starten;
function kromme(t : double) : vektor;

IMPLEMENTATION

procedure volgende(drS : vektor);
{
  Next "time" step
}
var
  v,drA : vektor;
begin
  v := plus(L,drS);
  case manier of
  0: drA := min(v,maal(lengte(L),een(v)));
  1: drA := min(maal(lengte(v),een(L)),L);
  end;
  rA := plus(rA,drA);
  rS := plus(rS,drS);
  L := maal(lengte(L),een(min(rS,rA)));
end;

procedure start_0;
{
  Initialize Road (0)
}
begin
  SetLength(start,6);
  start[0] := 0;
  start[1] := straal;
  start[2] := start[1] + straal*Pi/2;
  start[3] := start[2] + straal*Pi;
  start[4] := start[3] + straal*Pi/2;
  start[5] := start[4] + straal*2;
end;

procedure start_1;
{
  Initialize Road (1)
}
begin
  SetLength(start,6);
  start[0] := 0;
  start[1] := 3*straal;
  start[2] := start[1] + straal*2*Pi;
  start[3] := start[2] + straal*4;
end;

procedure starten;
{
  Which Road
}
begin
  case traject of
  0 : start_0;
  1 : start_1;
  end;
end;

function krom_0(t : double) : vektor;
{
  Define Road (0)
}
var
  k,taak : integer;
  hoek : double;
  h : vektor;
begin
  taak := 0;
  for k := 0 to 4 do
    if (start[k] <= t) and (t <= start[k+1]) then taak := k;
  case taak of
  0: begin
     h.x := t; h.y := 0; 
     end;
  1: begin
     hoek := (t-start[1])/straal + 3*Pi/2;
     h.x := straal + straal*cos(hoek);
     h.y := straal + straal*sin(hoek);
     end;
  2: begin
     hoek := - (t-start[2])/straal + Pi;
     h.x := 3*straal + straal*cos(hoek);
     h.y := straal + straal*sin(hoek);
     end;
  3: begin
     hoek := (t-start[3])/straal + Pi;
     h.x := 5*straal + straal*cos(hoek);
     h.y := straal + straal*sin(hoek);
     end;
  4: begin
     h.x := 5*straal + t-start[4]; h.y := 0; 
     end;
  end;
  h.y := h.y + straal/2;
  krom_0 := h;
end;

function krom_1(t : double) : vektor;
{
  Define Road (1)
}
var
  k,taak : integer;
  hoek : double;
  h : vektor;
begin
  taak := 0;
  for k := 0 to 2 do
    if (start[k] <= t) and (t <= start[k+1]) then taak := k;
  case taak of
  0: begin
     h.x := t; h.y := 0; 
     end;
  1: begin
     hoek := (t-start[1])/straal - Pi/2;
     h.x := 3*straal + straal*cos(hoek);
     h.y := straal + straal*sin(hoek);
     end;
  2: begin
     h.x := 3*straal + t-start[2]; h.y := 0; 
     end;
  end;
  h.y := h.y + straal/2;
  krom_1 := h;
end;

function kromme(t : double) : vektor;
{
  Which Road
}
var
  h : vektor;
begin
  case traject of
  0 : h := krom_0(t);
  1 : h := krom_1(t);
  end;
  kromme := h;
end;

END.
