Unit Wiskunde;
{
  Vector Algebra
}
INTERFACE

type
  vektor = record
    x,y : double;
  end;

function samen(x,y : double) : vektor;
function plus(a,b : vektor) : vektor;
function min(a,b : vektor) : vektor;
function maal(k : double; v : vektor) : vektor;
function lengte(v : vektor) : double;
function een(v : vektor) : vektor;
procedure druk(v : vektor);

IMPLEMENTATION

function samen(x,y : double) : vektor;
{
  Compose vector
  from components
}
var
  h : vektor;
begin
  h.x := x; h.y := y;
  samen := h;
end;

function plus(a,b : vektor) : vektor;
{
  Add vectors a and b
}
var
  h : vektor;
begin
  h.x := a.x + b.x; h.y := a.y + b.y;
  plus := h;
end;

function min(a,b : vektor) : vektor;
{
  Subtract vectors a and b
}
var
  h : vektor;
begin
  h.x := a.x - b.x; h.y := a.y - b.y;
  min := h;
end;

function maal(k : double; v : vektor) : vektor;
{
  Multiply vector v with scalar k
}
var
  h : vektor;
begin
  h.x := k*v.x; h.y := k*v.y;
  maal := h;
end;

function lengte(v : vektor) : double;
{
  Length of vector v
}
begin
  lengte := sqrt(sqr(v.x) + sqr(v.y));
end;

function een(v : vektor) : vektor;
{
  Normed vector v
}
var
  h : vektor;
  L : double;
begin
  L := sqrt(sqr(v.x) + sqr(v.y));
  h.x := v.x/L; h.y := v.y/L;
  een := h;
end;

procedure druk(v : vektor);
{
  Print components of vector v
}
begin
  Writeln('(',v.x,',',v.y,')');
end;

END.
